 import "Turbine.UI"; 
 import "Turbine.UI.Extensions"; 
 import "Turbine.UI.Lotro"; 

 import "Homeopatix.FoodAndDrinks.Globals"
 import "Homeopatix.FoodAndDrinks.MinimizedIcon"
 import "Homeopatix.FoodAndDrinks.VindarPatch"
 import "Homeopatix.FoodAndDrinks.Commands"
 import "Homeopatix.FoodAndDrinks.LoadSettings"

Turbine.Shell.WriteLine("<rgb=#CC56DA>FoodAndDrinks</rgb> <rgb=#DDDDDD>".. plugin:GetVersion() .." par Homeo</rgb>")

function SaveSettings()
		settings.positionX = tostring(settings.positionX);
   		settings.positionY = tostring(settings.positionY);
		settings.minimizeX = tostring(settings.minimizeX);
   		settings.minimizeY = tostring(settings.minimizeY);
		settings.isWindowVisible = settings.isWindowVisible;
		settings.shortcutData_1 = tostring(settings.shortcutData_1);
   		settings.shortcutData_2 = tostring(settings.shortcutData_2);
   		settings.shortcutData_3 = tostring(settings.shortcutData_3);
   		settings.shortcutData_4 = tostring(settings.shortcutData_4);
   		settings.shortcutData_5 = tostring(settings.shortcutData_5);
   		settings.shortcutData_6 = tostring(settings.shortcutData_6);
   		settings.shortcutData_7 = tostring(settings.shortcutData_7);
   
   -- save the settings
	PatchDataSave( Turbine.DataScope.Character, "FoodAndDrinks_Settings", settings);
end

CreateLocalizationInfo();

------------------------------------------------------------------------------------------
-- create the main window
------------------------------------------------------------------------------------------
FoodAndDrinksWindow=Turbine.UI.Lotro.GoldWindow(); 
FoodAndDrinksWindow:SetSize(300,100); 
FoodAndDrinksWindow:SetText(Strings.PluginName); 
FoodAndDrinksWindow.Message=Turbine.UI.Label(); 
FoodAndDrinksWindow.Message:SetParent(FoodAndDrinksWindow); 
FoodAndDrinksWindow.Message:SetSize(150,10); 
FoodAndDrinksWindow.Message:SetPosition(FoodAndDrinksWindow:GetWidth()/2 - 75, FoodAndDrinksWindow:GetHeight()/2 + 30); 
FoodAndDrinksWindow.Message:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter); 
FoodAndDrinksWindow.Message:SetText(Strings.PluginText); 
FoodAndDrinksWindow:SetZOrder(0);
FoodAndDrinksWindow:SetWantsKeyEvents(true);

LoadSettings();

function FoodAndDrinksWindow:Closing(sender, args)
	settings.isWindowVisible = false;
	SaveSettings();
end


FoodAndDrinksWindow:SetPosition(settings.positionX, settings.positionY);

------------------------------------------------------------------------------------------
-- handle minimizeIcon
------------------------------------------------------------------------------------------
MainMinimizedIcon = MinimizedIcon(Images.MinimizedIcon, 40, 40, FoodAndDrinksWindow:SetVisible(false));
settings.isWindowVisible = false;
SaveSettings();
MainMinimizedIcon:SetPosition(settings.minimizeX, settings.minimizeY);
MainMinimizedIcon:SetZOrder(0);
MainMinimizedIcon.PositionChanged = function()
	settings.minimizeX = MainMinimizedIcon:GetLeft();
	settings.minimizeY = MainMinimizedIcon:GetTop();
	SaveSettings();
end

------------------------------------------------------------------------------------------
-- yel helper center window
------------------------------------------------------------------------------------------
centerWindow = Turbine.UI.Extensions.SimpleWindow();
centerWindow:SetSize( 36 , 36 );
centerWindow:SetParent( FoodAndDrinksWindow );
centerWindow:SetPosition( 18 ,FoodAndDrinksWindow:GetHeight()/2 - 10);
centerWindow:SetVisible( true );
centerWindow:SetBackColor( Turbine.UI.Color( .6, .5, .7, .5) );

centerWindow2 = Turbine.UI.Extensions.SimpleWindow();
centerWindow2:SetSize( 36 , 36 );
centerWindow2:SetParent( FoodAndDrinksWindow );
centerWindow2:SetPosition( 56 ,FoodAndDrinksWindow:GetHeight()/2 - 10);
centerWindow2:SetVisible( true );
centerWindow2:SetBackColor( Turbine.UI.Color( .6, .5, .7, .5) );

centerWindow3 = Turbine.UI.Extensions.SimpleWindow();
centerWindow3:SetSize( 36 , 36 );
centerWindow3:SetParent( FoodAndDrinksWindow );
centerWindow3:SetPosition( 94,FoodAndDrinksWindow:GetHeight()/2 - 10);
centerWindow3:SetVisible( true );
centerWindow3:SetBackColor( Turbine.UI.Color( .6, .5, .7, .5) );

centerWindow4 = Turbine.UI.Extensions.SimpleWindow();
centerWindow4:SetSize( 36 , 36 );
centerWindow4:SetParent( FoodAndDrinksWindow );
centerWindow4:SetPosition( 132,FoodAndDrinksWindow:GetHeight()/2 - 10);
centerWindow4:SetVisible( true );
centerWindow4:SetBackColor( Turbine.UI.Color( .6, .5, .7, .5) );

centerWindow5 = Turbine.UI.Extensions.SimpleWindow();
centerWindow5:SetSize( 36 , 36 );
centerWindow5:SetParent( FoodAndDrinksWindow );
centerWindow5:SetPosition( 170,FoodAndDrinksWindow:GetHeight()/2 - 10);
centerWindow5:SetVisible( true );
centerWindow5:SetBackColor( Turbine.UI.Color( .6, .5, .7, .5) );

centerWindow6 = Turbine.UI.Extensions.SimpleWindow();
centerWindow6:SetSize( 36 , 36 );
centerWindow6:SetParent( FoodAndDrinksWindow );
centerWindow6:SetPosition( 208,FoodAndDrinksWindow:GetHeight()/2 - 10);
centerWindow6:SetVisible( true );
centerWindow6:SetBackColor( Turbine.UI.Color( .6, .5, .7, .5) );

centerWindow7 = Turbine.UI.Extensions.SimpleWindow();
centerWindow7:SetSize( 36 , 36 );
centerWindow7:SetParent( FoodAndDrinksWindow );
centerWindow7:SetPosition( 246,FoodAndDrinksWindow:GetHeight()/2 - 10);
centerWindow7:SetVisible( true );
centerWindow7:SetBackColor( Turbine.UI.Color( .5, .8, .5, .5) );

centerLabel = Turbine.UI.Label();
centerLabel:SetParent(centerWindow);
centerLabel:SetPosition( 0, 0 );
centerLabel:SetSize( 36, 36  );
centerLabel:SetText( "" );
centerLabel:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter );
centerLabel:SetZOrder(-1);
centerLabel:SetMouseVisible(false);

centerLabel = Turbine.UI.Label();
centerLabel:SetParent(centerWindow2);
centerLabel:SetPosition( 0, 0 );
centerLabel:SetSize( 36, 36  );
centerLabel:SetText( "" );
centerLabel:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter );
centerLabel:SetZOrder(-1);
centerLabel:SetMouseVisible(false);

centerLabel = Turbine.UI.Label();
centerLabel:SetParent(centerWindow3);
centerLabel:SetPosition( 0, 0 );
centerLabel:SetSize( 36, 36  );
centerLabel:SetText( "" );
centerLabel:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter );
centerLabel:SetZOrder(-1);
centerLabel:SetMouseVisible(false);

centerLabel = Turbine.UI.Label();
centerLabel:SetParent(centerWindow4);
centerLabel:SetPosition( 0, 0 );
centerLabel:SetSize( 36, 36  );
centerLabel:SetText( "" );
centerLabel:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter );
centerLabel:SetZOrder(-1);
centerLabel:SetMouseVisible(false);

centerLabel = Turbine.UI.Label();
centerLabel:SetParent(centerWindow5);
centerLabel:SetPosition( 0, 0 );
centerLabel:SetSize( 36, 36  );
centerLabel:SetText( "" );
centerLabel:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter );
centerLabel:SetZOrder(-1);
centerLabel:SetMouseVisible(false);

centerLabel = Turbine.UI.Label();
centerLabel:SetParent(centerWindow6);
centerLabel:SetPosition( 0, 0 );
centerLabel:SetSize( 36, 36  );
centerLabel:SetText( "" );
centerLabel:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter );
centerLabel:SetZOrder(-1);
centerLabel:SetMouseVisible(false);

centerLabel = Turbine.UI.Label();
centerLabel:SetParent(centerWindow7);
centerLabel:SetPosition( 0, 0 );
centerLabel:SetSize( 36, 36  );
centerLabel:SetText( "" );
centerLabel:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter );
centerLabel:SetZOrder(-1);
centerLabel:SetMouseVisible(false);

centerQS1 = Turbine.UI.Lotro.Quickslot();
centerQS1:SetParent( centerWindow );
centerQS1:SetPosition( 0, 0 );
centerQS1:SetSize( 35, 35 );
centerQS1:SetUseOnRightClick(false);

centerQS2 = Turbine.UI.Lotro.Quickslot();
centerQS2:SetParent( centerWindow2 );
centerQS2:SetPosition( 0, 0 );
centerQS2:SetSize( 35, 35 );
centerQS2:SetUseOnRightClick(false);

centerQS3 = Turbine.UI.Lotro.Quickslot();
centerQS3:SetParent( centerWindow3 );
centerQS3:SetPosition( 0, 0 );
centerQS3:SetSize( 35, 35 );
centerQS3:SetUseOnRightClick(false);

centerQS4 = Turbine.UI.Lotro.Quickslot();
centerQS4:SetParent( centerWindow4 );
centerQS4:SetPosition( 0, 0 );
centerQS4:SetSize( 35, 35 );
centerQS4:SetUseOnRightClick(false);

centerQS5 = Turbine.UI.Lotro.Quickslot();
centerQS5:SetParent( centerWindow5 );
centerQS5:SetPosition( 0, 0 );
centerQS5:SetSize( 35, 35 );
centerQS5:SetUseOnRightClick(false);

centerQS6 = Turbine.UI.Lotro.Quickslot();
centerQS6:SetParent( centerWindow6 );
centerQS6:SetPosition( 0, 0 );
centerQS6:SetSize( 35, 35 );
centerQS6:SetUseOnRightClick(false);

centerQS7 = Turbine.UI.Lotro.Quickslot();
centerQS7:SetParent( centerWindow7 );
centerQS7:SetPosition( 0, 0 );
centerQS7:SetSize( 35, 35 );
centerQS7:SetUseOnRightClick(false);

------------------------------------------------------------------------------------------
-- setting the shortcuts
------------------------------------------------------------------------------------------

if(settings.shortcutData_1 ~= "") then
	centerQS1:SetShortcut( Turbine.UI.Lotro.Shortcut( 2, settings.shortcutData_1 ) );
end

if(settings.shortcutData_2 ~= "") then
	centerQS2:SetShortcut( Turbine.UI.Lotro.Shortcut( 2, settings.shortcutData_2 ) );
end

if(settings.shortcutData_3 ~= "") then
	centerQS3:SetShortcut( Turbine.UI.Lotro.Shortcut( 2, settings.shortcutData_3 ) );
end

if(settings.shortcutData_4 ~= "") then
	centerQS4:SetShortcut( Turbine.UI.Lotro.Shortcut( 2, settings.shortcutData_4 ) );
end

if(settings.shortcutData_5 ~= "") then
	centerQS5:SetShortcut( Turbine.UI.Lotro.Shortcut( 2, settings.shortcutData_5 ) );
end

if(settings.shortcutData_6 ~= "") then
	centerQS6:SetShortcut( Turbine.UI.Lotro.Shortcut( 2, settings.shortcutData_6 ) );
end

if(settings.shortcutData_7 ~= "") then
	centerQS7:SetShortcut( Turbine.UI.Lotro.Shortcut( 2, settings.shortcutData_7 ) );
end
------------------------------------------------------------------------------------------
-- setting the shortcuts for drag and drop
------------------------------------------------------------------------------------------
centerQS1.DragDrop = function(sender, args)
	local tmp = Turbine.UI.Lotro.Quickslot();
		
	tmp = centerQS1:GetShortcut();
	tmp = tmp:GetData();
	
	local tmp2 = Turbine.UI.Lotro.Quickslot();
	tmp2 = centerQS1:GetShortcut();
	tmp2 = tmp2:GetType();

	
	--Turbine.Shell.WriteLine("Data : " .. tmp); -- display the ID of the schortcut
	--Turbine.Shell.WriteLine("Type : " .. tmp2); -- display the Type of the schortcut

	settings.shortcutData_1 = tmp;

	SaveSettings();
end
centerQS2.DragDrop = function(sender, args)
	local tmp = Turbine.UI.Lotro.Quickslot();
		
	tmp = centerQS2:GetShortcut();
	tmp = tmp:GetData();
	
	settings.shortcutData_2 = tmp;

	SaveSettings();
end
centerQS3.DragDrop = function(sender, args)
	local tmp = Turbine.UI.Lotro.Quickslot();
		
	tmp = centerQS3:GetShortcut();
	tmp = tmp:GetData();
	
	settings.shortcutData_3 = tmp;

	SaveSettings();
end
centerQS4.DragDrop = function(sender, args)
	local tmp = Turbine.UI.Lotro.Quickslot();
		
	tmp = centerQS4:GetShortcut();
	tmp = tmp:GetData();
	
	settings.shortcutData_4 = tmp;

	SaveSettings();
end
centerQS5.DragDrop = function(sender, args)
	local tmp = Turbine.UI.Lotro.Quickslot();
		
	tmp = centerQS5:GetShortcut();
	tmp = tmp:GetData();
	
	settings.shortcutData_5 = tmp;

	SaveSettings();
end
centerQS6.DragDrop = function(sender, args)
	local tmp = Turbine.UI.Lotro.Quickslot();
		
	tmp = centerQS6:GetShortcut();
	tmp = tmp:GetData();
	
	settings.shortcutData_6 = tmp;

	SaveSettings();
end
centerQS7.DragDrop = function(sender, args)
	local tmp = Turbine.UI.Lotro.Quickslot();
		
	tmp = centerQS7:GetShortcut();
	tmp = tmp:GetData();
	
	local tmp2 = Turbine.UI.Lotro.Quickslot();
	tmp2 = centerQS1:GetShortcut();
	tmp2 = tmp2:GetType();

	
	--Turbine.Shell.WriteLine("Data : " .. tmp); -- display the ID of the schortcut
	--Turbine.Shell.WriteLine("Type : " .. tmp2); -- display the Type of the schortcut
	
	settings.shortcutData_7 = tmp;

	SaveSettings();
end

------------------------------------------------------------------------------------------
-- delete the shortcut with mouse wheel
------------------------------------------------------------------------------------------

centerQS1.MouseWheel = function(sender, args)
	settings.shortcutData_1 = tostring(""); 
	centerQS1:SetShortcut(Turbine.UI.Lotro.Shortcut());
	SaveSettings();
end
centerQS2.MouseWheel = function(sender, args)
	settings.shortcutData_2 = tostring(""); 
	centerQS2:SetShortcut(Turbine.UI.Lotro.Shortcut());
	SaveSettings();
end
centerQS3.MouseWheel = function(sender, args)
	settings.shortcutData_3 = tostring(""); 
	centerQS3:SetShortcut(Turbine.UI.Lotro.Shortcut());
	SaveSettings();
end
centerQS4.MouseWheel = function(sender, args)
	settings.shortcutData_4 = tostring(""); 
	centerQS4:SetShortcut(Turbine.UI.Lotro.Shortcut());
	SaveSettings();
end
centerQS5.MouseWheel = function(sender, args)
	settings.shortcutData_5 = tostring(""); 
	centerQS5:SetShortcut(Turbine.UI.Lotro.Shortcut());
	SaveSettings();
end
centerQS6.MouseWheel = function(sender, args)
	settings.shortcutData_6 = tostring(""); 
	centerQS6:SetShortcut(Turbine.UI.Lotro.Shortcut());
	SaveSettings();
end
centerQS7.MouseWheel = function(sender, args)
	settings.shortcutData_7 = tostring(""); 
	centerQS7:SetShortcut(Turbine.UI.Lotro.Shortcut());
	SaveSettings();
end

-- last spot is for parchemin de combat and close the window
centerQS7.MouseClick = function(sender, args)
	FoodAndDrinksWindow:SetVisible(false);
	settings.isWindowVisible = false;
	SaveSettings();
end

               
------------------------------------------------------------------------------------------
-- event handling
------------------------------------------------------------------------------------------

FoodAndDrinksWindow.KeyDown=function(sender, args)
	if ( args.Action == Turbine.UI.Lotro.Action.Escape ) then
		FoodAndDrinksWindow:SetVisible(false);
		settings.isWindowVisible = false;
		SaveSettings();
	end
	
	-- https://www.lotro.com/forums/showthread.php?493466-How-to-hide-a-window-on-F12&p=6581962#post6581962
	if ( args.Action == 268435635 ) then
		hudVisible=not hudVisible;
		if hudVisible then
			FoodAndDrinksWindow:SetVisible(false);
			MainMinimizedIcon:SetVisible(false);
		else
			FoodAndDrinksWindow:SetVisible(settings.isWindowVisible);
			MainMinimizedIcon:SetVisible(true);
		end
	end
end
------------------------------------------------------------------------------------------
-- if the position changes, save the new window location
------------------------------------------------------------------------------------------
	FoodAndDrinksWindow.PositionChanged = function( sender, args )
    	local x,y = FoodAndDrinksWindow:GetPosition();
    	settings.positionX = x;
    	settings.positionY = y;
		SaveSettings();
	end

				
	



